Index: anr/section-consortium-people.tex
===================================================================
--- anr/section-consortium-people.tex	(revision 294)
+++ anr/section-consortium-people.tex	(revision 301)
@@ -21,49 +21,49 @@
 l'articulation entre les travaux proposes et les travaux anterieurs ou deja en
 cours.}
-\newenvironment{peopletabular}[1]{%
-  \begin{tabular}{|p{1.5cm}|p{1.5cm}|p{1.5cm}|p{1.5cm}|p{1.0cm}|p{.5cm}|p{6cm}|}\hline
-  #1 & Name & Fist name & Position & Field of resarch & PM & Contribution to the project \\\hline\hline
+
+\newenvironment{peopletabular}{%
+  \noindent\begin{tabular}{|p{1.8cm}|p{1.6cm}|p{1.6cm}|p{1.5cm}|p{1.0cm}|p{.5cm}|p{6cm}|}\hline
+    partner  & Name & F. name & Position & Fields & PM & Contribution to the project \\
   }{\end{tabular}\vspace{.75ex}\\}
 
-\begin{peopletabular}{\irisa}
+\def\peopletabularentry#1{\hline\hline\multicolumn{7}{|l|}{\textsc{#1}}\\\hline}
+
+\begin{peopletabular}
+
+\peopletabularentry{\irisa}
 ...         & Derien      & Steven      & ...                 & ...         & ... & ... \irisa \\\hline
 ...         & ...         & ...         & ...                 & ...         & ... & ... \\\hline
-\end{peopletabular}
 
-\begin{peopletabular}{\lip}
+\peopletabularentry{\lip}
 responsible & Feautrier   & Paul        & professor           & ...         & ... & ... \\\hline
 ...         & ...         & ...         & ...                 & ...         & ... & ... \\\hline
 ...         & ...         & ...         & ...                 & ...         & ... & ... \\\hline
-\end{peopletabular}
 
-\begin{peopletabular}{\tima}
-responsible & P\'{e}tro   & Fr\'ed\'eric& professor           & ...         & ... & ... \\\hline
+\peopletabularentry{\tima}
+responsible & P\'{e}trot   & Fr\'ed\'eric& professor           & ...         & ... & ... \\\hline
             & Muller      & Olivier     & assistant professor & ...         & ... & ... \\\hline
 ...         & ...         & ...         & ...                 & ...         & ... & ... \\\hline
-\end{peopletabular}
 
-\begin{peopletabular}{\ubs}
+\peopletabularentry{\ubs}
 responsible & Coussy      & Philippe    & ...                 & ...         & ... & ... \\\hline
 ...         & ...         & ...         & ...                 & ...         & ... & ... \\\hline
-\end{peopletabular}
 
-\begin{peopletabular}{\upmc}
-responsible & Greiner     & Alain       & professor           & SoC ...     & 36  & ... \\\hline
-            & Aug\'{e}    & Ivan        & assistant professor & HLS SOC HPC & 36  & ... \\\hline
-...         & ...         & ...         & ...                 & ...         & ... & ... \\\hline
-\end{peopletabular}                    
+\peopletabularentry{\upmc}
+responsible & Greiner     & Alain       & professor           & SOC ...     & 13  & Expertise in MPSoC design, virtual prototyping, micro-architecture.
+                                                                                    Responsible of Task-2. Participation to Task-3/6. \\\hline
+member      & Aug\'{e}    & Ivan        & assistant professor & HLS SOC HPC & 13  & Expertise in HLS, software development, kernel, SoC design, micro-architecture.
+                                                                                    Responsible of Task-3. Participation to Task-2/5/6/8. \\\hline
                                        
-\begin{peopletabular}{\mds}            
+\peopletabularentry{\mds}            
 responsible & Vaumorin    & Emannuel    & ...                 & ...         & ... & ... \\\hline
 ...         & ...         & ...         & ...                 & ...         & ... & ... \\\hline
-\end{peopletabular}                    
                                        
-\begin{peopletabular}{\bull}           
+\peopletabularentry{\bull}           
 responsible & Nguyen      & Huy-nam     & ...                 & HPC ...     & ... & ... \\\hline
 ...         & ...         & ...         & ...                 & ...         & ... & ... \\\hline
-\end{peopletabular}                                  
                                                      
-\begin{peopletabular}{\thales}                       
+\peopletabularentry{\thales}                       
 responsible & Lemonier    & Fabrice     & ...                 & ...         & ... & ... \\\hline
 ...         & ...         & ...         & ...                 & ...         & ... & ... \\\hline
+
 \end{peopletabular}